apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if do_backups %}
    backups.opsperator.io/driver: ssh
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
    backups.opsperator.io/secret: backups-{{ peertube_name }}
    backups.opsperator.io/service: backups-{{ peertube_name }}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ peertube_name }}
  name: {{ peertube_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ peertube_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ peertube_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ peertube_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ peertube_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ peertube_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ peertube_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: DO_LIVE
          value: "{{ 'tru' if (peertube_do_rtmp) else 'fals' }}e"
        - name: HTTP_PROXY
{% if proxy_host | default(False) %}
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: HTTPS_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
          value: {{ squid_address }}
        - name: HTTPS_PROXY
          value: {{ squid_address }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
          value: ""
        - name: HTTPS_PROXY
          value: ""
        - name: NO_PROXY
          value: ""
{% endif %}
        - name: LEMON_HOST
{% if do_lemon %}
          value: {{ lemon_portal | urlsplit('hostname') }}
{% else %}
          value: ""
{% endif %}
        - name: LEMON_PROTO
{% if do_lemon %}
          value: {{ lemon_portal | urlsplit('scheme') }}
{% else %}
          value: ""
{% endif %}
        - name: LIVE_INSTANCE_MAX
          value: "{{ peertube_max_lives }}"
        - name: LIVE_MAX_DURATION
          value: {{ peertube_live_max_duration }}
        - name: LIVE_TRANSCODE_THREADS
          value: "{{ peertube_live_transcode_threads }}"
        - name: LIVE_USER_MAX
          value: "{{ peertube_user_max_lives }}"
{% if do_ldap %}
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=peertube,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: peertube-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_CONF_DN_PREFIX
{% if do_lemon %}
          value: ou=lemonldap,ou=config
{% else %}
          value: ""
{% endif %}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
{% else %}
        - name: OPENLDAP_BASE
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_CONF_DN_PREFIX
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
{% endif %}
        - name: PEERTUBE_ADMIN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ peertube_name }}
        - name: PEERTUBE_CACHE_SIZE
          value: {{ peertube_cache_size }}B
        - name: PEERTUBE_CACHE_STRATEGY
          value: {{ peertube_cache_strategy }}
        - name: PEERTUBE_CACHE_TTLMIN
          value: {{ peertube_cache_ttl_min }}
        - name: PEERTUBE_DOMAIN
          value: {{ peertube_fqdn }}
        - name: PEERTUBE_HAS_NSFW
          value: "{{ 'tru' if (peertube_allow_nsfw) else 'fals' }}e"
        - name: PEERTUBE_NAME
          value: {{ peertube_site_name }}
        - name: PEERTUBE_NSFW_POLICY
          value: {{ peertube_nsfw_policy }}
        - name: POSTGRES_DB
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ ptpg_name }}
        - name: POSTGRES_HOST
          value: {{ ptpg_name }}
        - name: POSTGRES_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ ptpg_name }}
        - name: POSTGRES_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ ptpg_name }}
        - name: PUBLIC_PROTO
          value: https
        - name: REDIS_DB
          value: "1"
        - name: REDIS_HOST
          value: {{ cache_name }}
        - name: SAML_MAIL
          value: "{% if do_lemon %}mail{% endif %}"
        - name: SAML_USERNAME
          value: "{% if do_lemon %}uid{% endif %}"
        - name: SMTP_HOST
{% if smtp_relay | default(False) %}
          value: {{ smtp_relay }}
        - name: SMTP_PORT
          value: "{{ smtp_port | default('25') }}"
        - name: SMTP_PROTO
          value: smtp
        - name: SMTP_NO_STARTTLS
          value: "true"
{% elif smtps_address | default(False) %}
          value: {{ smtps_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtps_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtps
        - name: SMTP_NO_STARTTLS
          value: "false"
{% elif smtp_address | default(False) %}
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtp_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtp
        - name: SMTP_NO_STARTTLS
          value: "true"
{% else %}
          value: ""
        - name: SMTP_PORT
          value: ""
        - name: SMTP_PROTO
          value: ""
        - name: SMTP_NO_STARTTLS
          value: ""
{% endif %}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='peertube'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='peertube'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 28
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /
            port: 9000
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 5
        name: peertube
        ports:
        - containerPort: 9000
        readinessProbe:
          httpGet:
            path: /
            port: 9000
          initialDelaySeconds: 30
          periodSeconds: 15
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ peertube_cpu_limit }}"
            memory: "{{ peertube_memory_limit }}"
          requests:
            cpu: "{{ peertube_cpu_request }}"
            memory: "{{ peertube_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 30
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 9000
{% endif %}
        volumeMounts:
        - mountPath: /app/config
          name: data
          subPath: config
        - mountPath: /app/storage
          name: data
          subPath: storage
{% if (do_ldap or do_lemon or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
{% if do_ldap %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
{% if do_lemon %}
        - mountPath: /saml
          name: saml
{% endif %}
{% if do_exporters %}
      - env:
        - name: EXPORTER_PORT
          value: "9114"
        - name: PEERTUBE_URL
          value: http://127.0.0.1:9000
{% if do_triggers == False or (opsimages | json_query("[?name=='peertubeexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='peertubeexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 30
          httpGet:
            path: /
            port: 9114
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9114
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% endif %}
{% if do_backups %}
{% if do_triggers == False or (opsimages | json_query("[?name=='sshd'].short"))[0] == False %}
      - image: {{ (opsimages | json_query("[?name=='sshd'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
{% else %}
      - imagePullPolicy: {{ pull_policy }}
{% endif %}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 2222
          timeoutSeconds: 3
        name: sshd
        ports:
        - containerPort: 2222
        resources:
          limits:
            cpu: {{ sshd_cpu_limit }}
            memory: {{ sshd_memory_limit }}
          requests:
            cpu: "{{ sshd_cpu_request }}"
            memory: "{{ sshd_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /home/backup
          name: tmp
          subPath: bkphome
        - mountPath: /var/backup
          name: tmp
          subPath: bkpvar
        - mountPath: /.ssh/id_rsa.pub
          name: ssh
          subPath: id_rsa.pub
        - mountPath: /backups
          name: data
{% endif %}
{% if peertube_do_proxy %}
      - env:
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='peertubeproxy'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='peertubeproxy'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 10
          httpGet:
            path: /client/fr-FR/worker-basic.min.js
            port: 8080
          initialDelaySeconds: 10
          periodSeconds: 15
          timeoutSeconds: 5
        name: nginx
        ports:
        - containerPort: 8080
        - containerPort: 9112
        readinessProbe:
          failureThreshold: 3
          httpGet:
            path: /client/fr-FR/worker-basic.min.js
            port: 8080
          initialDelaySeconds: 10
          periodSeconds: 15
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ peertube_proxy_cpu_limit }}"
            memory: "{{ peertube_proxy_memory_limit }}"
          requests:
            cpu: "{{ peertube_proxy_cpu_request }}"
            memory: "{{ peertube_proxy_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /var/lib/nginx
          name: data
          subPath: proxy
        - mountPath: /var/run
          name: tmp
          subPath: nginx
        - mountPath: /var/www/peertube/storage
          name: data
          subPath: storage
{% if do_exporters %}
      - args:
        - --nginx.scrape-uri
        - http://127.0.0.1:9112/basic_status
{% if do_triggers == False or (opsimages | json_query("[?name=='nginxexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='nginxexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 9113
          timeoutSeconds: 3
        name: nginxxp
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% endif %}
      hostAliases:
      - ip: 127.0.0.1
        hostnames:
        - peertube
{% else %}
      hostAliases: []
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if (rwx_storage | default(False) and rwx_needs_fsgroup | default(False)) or (rwx_storage is not defined and rwo_needs_fsgroup | default(False)) %}
      securityContext:
{% if rwx_storage | default(False) and rwx_needs_fsgroup | default(False) %}
        fsGroup: {{ rwx_needs_fsgroup }}
{% elif rwx_storage is not defined and rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ peertube_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: data
        persistentVolumeClaim:
          claimName: {{ peertube_name }}
{% if do_ldap %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
{% if (do_ldap or do_lemon or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
{% if do_ldap or do_lemon %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if smtps_address | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: smtp-ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
{% if do_lemon %}
      - name: saml
        projected:
          sources:
          - secret:
              items:
              - key: tls.crt
                path: tls.crt
              name: {{ peertube_name }}-saml
          - secret:
              items:
              - key: tls.key
                path: tls.key
              name: {{ peertube_name }}-saml
          - secret:
              items:
              - key: tls.crt
                path: lemon.crt
              name: {{ lemon_name }}-saml
{% endif %}
{% if do_backups %}
      - name: ssh
        secret:
          secretName: backups-{{ peertube_name }}
{% endif %}
{% if peertube_do_proxy or do_backups %}
      - emptyDir: {}
        name: tmp
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='peertube'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - peertube
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='peertube'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_exporters and (opsimages | json_query("[?name=='peertubeexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='peertubeexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_backups and (opsimages | json_query("[?name=='sshd'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - sshd
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sshd'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if peertube_do_proxy and (opsimages | json_query("[?name=='peertubeproxy'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - nginx
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='peertubeproxy'].short"))[0] }}
        namespace: {{ buildns }}
{% if do_exporters and (opsimages | json_query("[?name=='nginxexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - nginxxp
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='nginxexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% endif %}
  - type: ConfigChange
{% endif %}
